/***************************************************************************
 *
 *  ZXEmuT -- ZX Spectrum Emulator with Tcl scripting
 *
 *  Copyright (C) 2012-2022 Ketmar Dark <ketmar@ketmar.no-ip.org>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, version 3 of the License ONLY.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **************************************************************************/
#ifndef ZXEMUT_VIDEO_H
#define ZXEMUT_VIDEO_H

#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <stddef.h>
#include <SDL.h>

#ifdef __cplusplus
extern "C" {
#endif


////////////////////////////////////////////////////////////////////////////////
enum {
  MS_BUTTON_LEFT      = 0x01,
  MS_BUTTON_RIGHT     = 0x02,
  MS_BUTTON_MIDDLE    = 0x04,
  MS_BUTTON_WHEELUP   = 0x10,
  MS_BUTTON_WHEELDOWN = 0x20,
  //
  MS_BUTTON_AUTO      = 0x80, // autogenerated mouse press
  //
  MS_BUTTON_MASK = 0xff, // ignore 'depressed' flag for mouseButtonCB
  MS_BUTTON_DEPRESSED = 0x100,
};


typedef void (*FrameCB) (void);
typedef void (*KeyCB) (SDL_KeyboardEvent *key);
typedef void (*MouseCB) (int x, int y, int xrel, int yrel, int buttons);
typedef void (*MouseButtonCB) (int x, int y, int button, int buttons);
typedef void (*WindowActivationCB) (int activated);


extern FrameCB frameCB;
extern KeyCB keyCB;
extern MouseCB mouseCB;
extern MouseButtonCB mouseButtonCB; // button: which button state was changed (possibly with MS_BUTTON_DEPRESSED)
extern WindowActivationCB windowActivationCB;
  // on deactivation, keyboard and mouse button handlers will be called for
  // pressed control keys and mouse buttons before this callback

//HACK! valid only for mouse handler
extern int msRealX, msRealY;

extern int msButtons, msLastX, msLastY, kbCtrl, kbAlt, kbShift;
extern int kbLCtrl, kbRCtrl, kbLAlt, kbRAlt, kbLShift, kbRShift;
extern int msAutoTimeMSFirst; // mouse button autorepeat event time in milliseconds; <1: never
extern int msAutoTimeMSRepeat; // mouse button autorepeat event time in milliseconds; <1: never
extern int msAutoTresholdX, msAutoTresholdY;

extern const uint8_t vid_font8x16[4096];
extern const uint8_t vid_font8x8[2048];


////////////////////////////////////////////////////////////////////////////////
extern int optFullscreen;
extern int optTVScaler;
extern int vidScale; // 1, 2, 3, 4; default is 3
extern SDL_Surface *screen; // always 32bpp
extern SDL_Surface *screenReal; // always 32bpp
extern Uint32 palette[256]; // converted for frameSfc
extern unsigned paletteUsed; // used colors in the palette
extern uint8_t palRGB[256][4]; // [3] is unused
extern int vidRIdx, vidGIdx, vidBIdx;
extern SDL_Surface *frameSfc; // current frame surface for FrameCB

enum {
  VID_SCALER_NONE,
  VID_SCALER_nX,
  VID_SCALER_HQX,

  VID_SCALER_MAX,
};

extern int vid_scaler_type;

extern int vidWindowActivated;

extern int vidColorMode; // 0:normal; 1:b/w; 2:green; 3:yellow; 4:cyan; 5:magenta; 6:red

// if set, this is called after real screen was built
// can be used to render various fullscreen things
// use *ONLY* `sfc` to render things
// note that surface is properly locked here
extern void (*vidBeforeFlipCB) (SDL_Surface *sfc);

typedef struct __attribute__((packed)) {
  uint8_t ch;
  uint8_t attr; // low 4 bits:fg; high 4 bits:bg
} VidTChar;

#define VID_TEXT_WIDTH   (80)
#define VID_TEXT_HEIGHT  (30)

extern VidTChar vid_textscr[VID_TEXT_WIDTH*VID_TEXT_HEIGHT];
extern int vid_textscr_active;
extern int vid_textsrc_height; // <= 0: full


extern void vt_cls (uint8_t ch, uint8_t attr);
extern void vt_writechar (int x, int y, uint8_t ch, uint8_t attr);
extern void vt_writechars (int x, int y, int count, uint8_t ch, uint8_t attr);
extern void vt_writestrz (int x, int y, const char *s, uint8_t attr);
extern void vt_writestrcnt (int x, int y, const char *s, size_t slen, uint8_t attr);

extern void vt_writeva (int x, int y, uint8_t attr, const char *fmt, va_list ap);
extern void vt_writef (int x, int y, uint8_t attr, const char *fmt, ...) __attribute__((format(printf,4,5)));

extern void vt_writeattr (int x, int y, uint8_t attr);
extern void vt_writeattrs (int x, int y, int count, uint8_t attr);

extern void vt_draw_shadow (int x, int y, int w, int h);

#define VID_FRAME_SINGLE     (0x00U)
#define VID_FRAME_DOUBLE     (0x01U)
#define VID_FRAME_OVERWRITE  (0x10U)
#define VID_FRAME_FILL       (0x40U)
#define VID_FRAME_SHADOW     (0x80U)

extern void vt_draw_frame_ex (int x, int y, int w, int h, uint8_t attr, unsigned flags,
                              const char *title);
extern void vt_draw_frame (int x, int y, int w, int h, uint8_t attr, unsigned flags);

extern void vt_fill_rect (int x, int y, int w, int h, uint8_t attr);


typedef struct {
  int x, y;
  int w, h;
  int cursor_y;
  int page_top;
  int textview;
  uint8_t clr_frame, clr_win, clr_prompt;
  uint8_t clr_item, clr_cursor; // for text view, headers and normal text
  char *prompt;
  char **items;
  uint32_t item_count;
} vt_simple_menu;


// copies all data to dynamic memory!
extern void vt_smm_init (vt_simple_menu *menu, const char *prompt, const char *items[]);
// simple text viewer; headers starts with "\x01"
extern void vt_smm_init_textview (vt_simple_menu *menu, const char *prompt, const char *items[]);
// releases all data, don't forget to call it!
extern void vt_smm_deinit (vt_simple_menu *menu);

extern void vt_smm_draw (vt_simple_menu *menu);

// `vt_smm_draw()` will automatically call this
// but `vt_smm_process_key()` will not
extern void vt_smm_ensure_cursor_visible (vt_simple_menu *menu);

#define VID_SMM_ESCAPE    (-1)
#define VID_SMM_NOTMINE   (0)
#define VID_SMM_EATEN     (1)
#define VID_SMM_SELECTED  (2)

// return VID_SMM_xxx
extern int vt_smm_process_key (vt_simple_menu *menu, SDL_KeyboardEvent *key);


////////////////////////////////////////////////////////////////////////////////
enum {
  TIMER_ERROR = -1,
  TIMER_HPET = 0,
  TIMER_OTHER = 1
};


extern int timerInit (void); // return TIMER_XXX
extern int timerReinit (void); // reset timer; <0: error
extern int64_t timerGetMS (void); // milliseconds
extern int64_t timerGetMicroSeconds (void); // microseconds


////////////////////////////////////////////////////////////////////////////////
extern void sdlInit (void);
extern void initVideo (void);
extern void switchFullScreen (void);
extern void updateScale (void);

extern void rebuildPalette (void);

extern uint8_t zxPalette[];


////////////////////////////////////////////////////////////////////////////////
// NO LOCKING!
static inline void putPixel (int x, int y, Uint8 col) {
  if (frameSfc != NULL && col != 255 && x >= 0 && y >= 0 && x < frameSfc->w && y < frameSfc->h) {
    *(Uint32 *)(((Uint8 *)frameSfc->pixels)+(y*frameSfc->pitch)+x*4) = palette[col];
  }
}


static inline void putPixelMix (int x, int y, Uint8 col0, Uint8 col1) {
  if (frameSfc != NULL && x >= 0 && y >= 0 && x < frameSfc->w && y < frameSfc->h) {
    Uint8 *d = (((Uint8 *)frameSfc->pixels)+(y*frameSfc->pitch)+x*4);
    Uint32 r = palRGB[col0][0], g = palRGB[col0][1], b = palRGB[col0][2];
    //
    d[vidRIdx] = (palRGB[col1][0]+r)/2;
    d[vidGIdx] = (palRGB[col1][1]+g)/2;
    d[vidBIdx] = (palRGB[col1][2]+b)/2;
  }
}


////////////////////////////////////////////////////////////////////////////////
typedef struct {
  SDL_Surface *s;
  int needUnlock;
} SurfaceLock;


extern void lockSurface (SurfaceLock *lock, SDL_Surface *s);
extern void unlockSurface (SurfaceLock *lock);

extern void clearScreen (Uint8 col);


////////////////////////////////////////////////////////////////////////////////
// surface must be locked!
extern void drawChar6 (char ch, int x, int y, Uint8 fg, Uint8 bg);
extern void drawStr6 (const char *str, int x, int y, Uint8 fg, Uint8 bg);
extern void drawChar8 (char ch, int x, int y, Uint8 fg, Uint8 bg);
extern void drawStr8 (const char *str, int x, int y, Uint8 fg, Uint8 bg);
extern void drawStr6Outline (const char *str, int x, int y, Uint8 fg, Uint8 oc);
extern void drawStr8Outline (const char *str, int x, int y, Uint8 fg, Uint8 oc);

extern int drawCharZ (char ch, int x, int y, Uint8 c1, Uint8 c2);
extern int drawStrZ (const char *str, int x, int y, Uint8 c1, Uint8 c2);

extern void drawBar (int x, int y, int w, int h, Uint8 c);


////////////////////////////////////////////////////////////////////////////////
// forcedShowFrame() can be called from FrameCB to force showing the current frame
// ugly name means that you shouldn't use it
// video module will not show the frame by itself if forcedShowFrame() was called
extern void forcedShowFrame (void);

extern void buildFrame (void);
extern int processEvents (int dowait);
extern void mainLoop (void);
extern void postQuitMessage (void);


////////////////////////////////////////////////////////////////////////////////
typedef struct {
  int w, h;
  uint8_t *data;
} VOverlay;


extern VOverlay *createVO (int w, int h);
extern void resizeVO (VOverlay *v, int w, int h);
extern void freeVO (VOverlay *v);

extern void clearVO (VOverlay *v, Uint8 c);

extern void drawChar6VO (VOverlay *v, char ch, int x, int y, Uint8 fg, Uint8 bg);
extern void drawStr6VO (VOverlay *v, const char *str, int x, int y, Uint8 fg, Uint8 bg);
extern void drawChar8VO (VOverlay *v, char ch, int x, int y, Uint8 fg, Uint8 bg);
extern void drawStr8VO (VOverlay *v, const char *str, int x, int y, Uint8 fg, Uint8 bg);

extern void drawFrameVO (VOverlay *v, int x0, int y0, int w, int h, Uint8 c);
extern void fillRectVO (VOverlay *v, int x0, int y0, int w, int h, Uint8 c);

extern void blitVO (VOverlay *v, int x0, int y0, Uint8 alpha);


extern VOverlay *createVOFromIcon (const void *iconbuf);


static inline void putPixelVO (VOverlay *v, int x, int y, Uint8 c) {
  if (v != NULL && x >= 0 && y >= 0 && x < v->w && y < v->h && c != 255) v->data[y*v->w+x] = c;
}


// dynamically allocate rgb colors
extern void vidResetPalette (void);
extern uint8_t vidAllocColor (int r, int g, int b);


////////////////////////////////////////////////////////////////////////////////
// rectangle that *includes* right and bottom edges
typedef struct {
  int vClipX0, vClipY0;
  int vClipX1, vClipY1;
  int vOfsX, vOfsY;
} VClipInfo;


typedef struct {
  VOverlay *vo;
  VClipInfo clip;
} VExSurface;


////////////////////////////////////////////////////////////////////////////////
static inline void vPutPixel (const VExSurface *sfc, int x, int y, Uint8 clr) {
  if (sfc != NULL && sfc->vo != NULL) {
    x += sfc->clip.vOfsX;
    y += sfc->clip.vOfsY;
    if (x >= sfc->clip.vClipX0 && y >= sfc->clip.vClipY0 &&
        x <= sfc->clip.vClipX1 && y <= sfc->clip.vClipY1) putPixelVO(sfc->vo, x, y, clr);
  }
}


////////////////////////////////////////////////////////////////////////////////
static inline void vResetClip (VExSurface *sfc) {
  if (sfc != NULL) {
    sfc->clip.vClipX0 = sfc->clip.vClipY0 = 0;
    sfc->clip.vClipX1 = sfc->vo->w-1;
    sfc->clip.vClipY1 = sfc->vo->h-1;
    sfc->clip.vOfsX = sfc->clip.vOfsY = 0;
  }
}


static inline void vSetClip (VExSurface *sfc, int x, int y, int w, int h, int ox, int oy) {
  if (sfc != NULL) {
    if (w < 0) w = 0;
    if (h < 0) h = 0;
    sfc->clip.vClipX0 = x;
    sfc->clip.vClipY0 = y;
    sfc->clip.vClipX1 = x+w-1;
    sfc->clip.vClipY1 = y+h-1;
    sfc->clip.vOfsX = ox;
    sfc->clip.vOfsY = oy;
  }
}


static inline void vSaveClip (const VExSurface *sfc, VClipInfo *ci) {
  if (sfc != NULL && ci != NULL) *ci = sfc->clip;
}


static inline void vRestoreClip (VExSurface *sfc, const VClipInfo *ci) {
  if (sfc != NULL && ci != NULL) sfc->clip = *ci;
}


static inline void vRestrictClip (VExSurface *sfc, int x, int y, int w, int h) {
  if (sfc != NULL) {
    if (w < 1 || h < 1 || x > sfc->clip.vClipX1 || y > sfc->clip.vClipY1) {
      sfc->clip.vClipX1 = sfc->clip.vClipX0-1;
      sfc->clip.vClipY1 = sfc->clip.vClipY0-1;
    } else {
      if (sfc->clip.vClipX0 < x) sfc->clip.vClipX0 = x;
      if (sfc->clip.vClipY0 < y) sfc->clip.vClipY0 = y;
      x += w-1;
      y += h-1;
      if (sfc->clip.vClipX1 > x) sfc->clip.vClipX1 = x;
      if (sfc->clip.vClipY1 > y) sfc->clip.vClipY1 = y;
    }
  }
}


static inline void vChangeClip (VExSurface *sfc, int dhor, int dvert) {
  if (sfc != NULL) {
    sfc->clip.vClipX0 += dhor;
    sfc->clip.vClipY0 += dvert;
    sfc->clip.vClipX1 -= dhor;
    sfc->clip.vClipY1 -= dvert;
  }
}


////////////////////////////////////////////////////////////////////////////////
extern int vLineCountMaxLen (const char *str, int *maxlenp);

extern void vDrawChar (VExSurface *sfc, int x, int y, char ch, Uint8 ink, Uint8 paper);
extern void vDrawText (VExSurface *sfc, int x, int y, const char *str, Uint8 ink, Uint8 paper);
extern void vDrawOutlineText (VExSurface *sfc, int x, int y, const char *str, Uint8 ink, int oink);

////////////////////////////////////////////////////////////////////////////////
extern void vDrawHLine (VExSurface *sfc, int x, int y, int len, Uint8 clr);
extern void vDrawVLine (VExSurface *sfc, int x, int y, int len, Uint8 clr);
extern void vDrawBar (VExSurface *sfc, int x, int y, int width, int height, Uint8 clr);
extern void vDrawRect (VExSurface *sfc, int x, int y, int width, int height, Uint8 clr);
extern void vDrawRectW (VExSurface *sfc, int x, int y, int width, int height, Uint8 clr);

////////////////////////////////////////////////////////////////////////////////
extern void vDrawZXStripe (VExSurface *sfc, int x, int y, int dim);

enum {
  ZXVIDWF_STRIPES = 0x01,
  ZXVIDWF_STRIPES_DIM = 0x02, // dim colors
};

extern void vDrawWindow (VExSurface *sfc, int x, int y, int width, int height, const char *title,
  int tink, int tpaper, int wpaper, int flags);

////////////////////////////////////////////////////////////////////////////////
extern void vDrawUpArrow (VExSurface *sfc, int x, int y, Uint8 ink, Uint8 paper);
extern void vDrawDownArrow (VExSurface *sfc, int x, int y, Uint8 ink, Uint8 paper);
extern void vDrawLeftArrow (VExSurface *sfc, int x, int y, Uint8 ink, Uint8 paper);
extern void vDrawRightArrow (VExSurface *sfc, int x, int y, Uint8 ink, Uint8 paper);

////////////////////////////////////////////////////////////////////////////////
extern void vDrawLine (VExSurface *sfc, int x0, int y0, int x1, int y1, Uint8 clr);
extern void vDrawCircle (VExSurface *sfc, int cx, int cy, int radius, Uint8 clr);
extern void vDrawEllipse (VExSurface *sfc, int x0, int y0, int x1, int y1, Uint8 clr);
extern void vDrawFilledCircle (VExSurface *sfc, int cx, int cy, int radius, Uint8 clr);
extern void vDrawFilledEllipse (VExSurface *sfc, int x0, int y0, int x1, int y1, Uint8 clr);

////////////////////////////////////////////////////////////////////////////////
extern void vDrawSelectionRect (VExSurface *sfc, int phase, int x0, int y0, int wdt, int hgt, Uint8 col0, Uint8 col1);


////////////////////////////////////////////////////////////////////////////////
// there are many predefined cursors...
enum {
  AID_DEFAULT = -1, // AID_COOKE
  AID_BIG = 0,
  AID_LESSER,
  AID_UGLY,
  AID_UGLYIER,
  AID_TINY_BGE,
  AID_COOKE,
  AID_ARTSTUDIO,
  AID_SMALL_BYTEX,
  AID_UGLY_EXCESS,
  AID_EMPTY
};

extern Uint8 msCurClr0, msCurClr1;

extern void drawMouseCursor (int x, int y, int id);


#ifdef __cplusplus
}
#endif
#endif
